<?php
/*
Plugin Name: ecSTATic
Plugin URI: http://www.kayak2u.com/blog/ecstatic/
Description: Faster, Smaller, Non-Ecological Visitor Stats and Management for Wordpress Blogs
Version: 0.97
Author: MikeSoja, BVD
Author URI: http://www.kayak2u.com/blog/ecstatic/
*/
/***********************************************************************************/
class ecstatic {
public $version = '0.97';
public $url = "";
public $schost = "";
public $bob = "";
public $datetime = '';
public $timezoneoffset = 0;
public $logsubadmin = false;
public $score = 0;
public $options = array();
public $option_defaults = array("showbannergraph" => 1, "showgraphregi" => 1, "showgraphregp" => 1, "showgraphfeedi" => 1, "showgraphfeedp" => 0, "showgraphboti" => 1, "showgraphbotp" => 0, "showreg" => 1, "showfeed" => 1, "showbot" => 1, "collectloggeduser" => 0, "daystograph" => 32, "purgeolderthan" => 60, "purgerssolderthan" => 15, "purgebotolderthan" => 30, "daystoshow" => 1, "maxtoshow" => 64, "newvisitorminutes" => 60, "mal_ip" => 10, "empty_ua" => 4, "empty_ref" => 0, "trackback" => 0, "login" => 4, "lostpassword" => 4, "panel1" => "reg", "panel2" => "feed", "panel3" => "bot", "topentriestoshow" => 25, "graphsort" => 0, "noprefetch" => 1, "enablewidget" => 0, "logsubadmin" => 0, "dom_check" => 0, "dom_check_at" => 4, "dom_check_score" => 4, "dom_method" => 1, "wtf" => 0, "wtf_x" => 8, "wtf_secs" => 2, "block_new_bots" => 0, "skip_rip" => 0, "stop_popups" => 0, "stop_popups_beyond" => 500, "no_lowscore_popups" => 7, "estats" => 0);
//changes to options must be made in five (six, if a string option is changed) places.
//$option_defaults above
//ecstatic_tables.php ecstatic_create_table
//ecstatic_tables.php ecstatic_populate_table - only if the new option is a string
//ecstatic_tables.php ecstatic_versionista
//ecstatic_forms.php option_form - change the input form
//ecstatic_forms.php process_option_changes - three places
public $options_table;
public $hits_table;
public $cumulative_table;
public $aux_se_table;
public $aux_lists_table;
public $iurr_tables = array();

/***********************************************************************************/
function get_options() {
global $wpdb;
$this->options = $wpdb->get_row("SELECT * FROM $this->options_table", ARRAY_A);
foreach ($this->option_defaults as $key => $value)
	if (!isset($this->options[$key]))
		$this->options[$key] = $value;

if ($this->options["logsubadmin"] AND !(current_user_can('administrator')))
	$this->logsubadmin = true;

$this->url = get_option("siteurl");
$base = parse_url($this->url);
$this->schost = $base["scheme"] . "://" . $base["host"];
$len = strlen($this->schost);
if (strlen($this->url) > $len)
	$this->bob = substr($this->url, $len);

$this->timezoneoffset = get_option("gmt_offset");
if ($this->version != $this->options["version"]) {
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_tables.php');
	ecstatic_versionista($this);
	}
} //get_options

/***********************************************************************************/
function make_table($tana) {
global $wpdb;
$table_name = $wpdb->prefix . "ecstatic_" . $tana;
if ($wpdb->get_var("SHOW TABLES LIKE '{$table_name}'") != $table_name) {
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_tables.php');
	ecstatic_create_table($this, $tana);
	ecstatic_populate_table($this, $tana);
	}
return $table_name;
} //make_table

public $ips = array();

/***********************************************************************************/
function load_ips($token) {
$min = str_replace("*", "0", $token);
$min = str_replace("?", "0", $min);
$max = str_replace("*", "255", $token);
$max = str_replace("?", "9", $max);
$minocts = explode(".", $min);
$maxocts = explode(".", $max);
for ($i=0; $i<4; $i++) {
	if (strpos($minocts[$i],"-") !== false)
		list($minocts[$i], $maxocts[$i]) = explode("-", $minocts[$i]);
	if ($minocts[$i] > 255)
		$minocts[$i] = 0;
	if ($maxocts[$i] > 255)
		$maxocts[$i] = 255;
	}
$this->ips[$token]["min"] = (float)sprintf("%u", ip2long($minocts[0] . "." . $minocts[1] . "." . $minocts[2] . "." . $minocts[3]));
$this->ips[$token]["max"] = (float)sprintf("%u", ip2long($maxocts[0] . "." . $maxocts[1] . "." . $maxocts[2] . "." . $maxocts[3]));
} //load_ips

/***********************************************************************************/
function is_in_lists2($ip2check, $ua2check, $ref2check, $ruri2check, $wnks=0) { //wlist, nolog, kill, spider
global $wpdb;
$arobj = array();
static $record;
if (!$record) {
	$record = $wpdb->get_results("SELECT name, token, type, wnks FROM $this->aux_lists_table");
	foreach ($record as $r)
		if ($r->type == "ip")
			$this->load_ips($r->token);
	}
$ip2checkf = (float)sprintf("%u", ip2long($ip2check));
$ua2check = str_replace(" ", "", strtolower($ua2check));
foreach ($record as $rec) {
	if ($rec->wnks & $wnks) {
		switch ($rec->type) {
			case "ip":
				if ($ip2check != "" AND $ip2checkf >= $this->ips[$rec->token]["min"] AND $ip2checkf <= $this->ips[$rec->token]["max"])
					$arobj[] = $rec;
				break;
			case "ua":
				if (strpos($ua2check, $rec->token) !== false)
					$arobj[] = $rec;
				break;
			case "ref":
				if (strpos($ref2check, $rec->token) !== false)
					$arobj[] = $rec;
				break;
			case "ruri":
				if (strpos($ruri2check, $rec->token) !== false)
					$arobj[] = $rec;
				break;
			} //switch
		} //if
	} //foreach
return $arobj;
} //is_in_lists2

/******************************************CONSTRUCTOR****************************/
function __construct() {
if (function_exists("date_default_timezone_set"))
	date_default_timezone_set(get_option('timezone_string'));
$this->datetime = time();
$this->options_table = $this->make_table("options");
$this->hits_table = $this->make_table("hits");
$this->cumulative_table = $this->make_table("cumulative");
$this->aux_se_table = $this->make_table("aux_se");
$this->aux_lists_table = $this->make_table("aux_lists");
$this->iurr_tables["ip"] = $this->make_table("ips");
$this->iurr_tables["ua"] = $this->make_table("user_agents");
$this->iurr_tables["ref"] = $this->make_table("refs");
$this->iurr_tables["ruri"] = $this->make_table("ruris");
$this->get_options();
} //ecstatic constructor
} //class ecstatic
/***********************************************************************************/
/***********************************************************************************/
class ecstatic_get_host {
private $raw_nsr = "";
private $full_domain_name = "";
private $domain_name = "";
/****************************************************/
function full_domain_name(){
if ($this->host_error[$this->full_domain_name])
	return $this->host_error[$this->full_domain_name];
else
	return $this->full_domain_name;
} //full_domain_name
/****************************************************/
function domain_name($dm=""){
if ($dm)
	$this->domain_name = $dm;
if ($this->host_error[$this->domain_name])
	return $this->host_error[$this->domain_name];
else
	return $this->domain_name;
} //domain_name
/****************************************************/
function raw_nsr(){ //for debuggin'
return $this->raw_nsr;
} //raw_nsr
/****************************************************/
function is_domain_error(){
if (!$this->domain_name OR $this->host_error[$this->domain_name])
	return true;
else
	return false;
} //is_domain_error
private $host_error = array("1(FORMERR)"=>"Format Error", "2(SERVFAIL)"=>"(ServerFail)", "3(NXDOMAIN)"=>"(Non-existent)", "4(NOTIMP)"=>"Not Implemented", "5(REFUSED)"=>"Query Refused", "6(YXDOMAIN)"=>"Name Exists when it should not", "7(YXRRSET)"=>"RR Set Exists when it should not", "8(NXRRSET)"=>"RR Set that should exist does not", "9(NOTAUTH)"=>"Server Not Authoritative for zone", "10(NOTZONE)"=>"Name not contained in zone", "TO"=>"(timed out)", "timed out"=>"(timed out)", "(empty)" => "(Empty)", "hosterr" => "('host' err)", "NA"=>"(NotAvailable)");
private $nslookup_error = array("FORMERR"=>"1(FORMERR)", "SERVFAIL"=>"2(SERVFAIL)", "NXDOMAIN"=>"3(NXDOMAIN)", "NOTIMP"=>"4(NOTIMP)", "REFUSED"=>"5(REFUSED)", "YXDOMAIN"=>"6(YXDOMAIN)", "YXRRSET"=>"7(YXRRSET)", "NXRRSET"=>"8(NXRRSET)", "NOTAUTH"=>"9(NOTAUTH)", "NOTZONE"=>"10(NOTZONE)", "TO"=>"TO", "timed out"=>"timed out", "(empty)"=>"(Empty)", "hosterr"=>"'host' error");
/***************************************/
function ghba($ip) {
$this->raw_nsr = gethostbyaddr($ip);
if ($this->raw_nsr == $ip)
	$this->full_domain_name = $this->domain_name = "NA";
else
	$this->full_domain_name = $this->raw_nsr;
} //ghba
/***************************************/
function dgr($ip) {
$ptr= implode(".", array_reverse(explode(".", $ip))) . ".in-addr.arpa";
$this->raw_nsr = @dns_get_record($ptr, DNS_PTR);
if ($this->raw_nsr == null)
	$this->full_domain_name = $this->domain_name = "NA";
else
	$this->full_domain_name = $raw[0]["target"];
} //dgr
/***************************************/
function dig($ip) {
$ptr = implode(".", array_reverse(explode(".", $ip))) . ".in-addr.arpa";
$raw = $this->raw_nsr = shell_exec("dig ptr {$ptr}");
if (strpos($raw, "timed out") !== false)
	$this->full_domain_name = "TO";
elseif (preg_match('/;; ANSWER SECTION.*\n.*PTR\s+(.*).\n/', $raw, $matches))
	$this->full_domain_name = $matches[1];
elseif (preg_match('/status[:\s]*(.*),/', $raw, $matches))
	$this->full_domain_name = $this->nslookup_error[$matches[1]];
} //dig
/***************************************/
function nslookup($ip) {
$raw = $this->raw_nsr = shell_exec("nslookup -timeout=3 -retry=0 {$ip}");
if (strpos($raw, "timed out") !== false)
	$this->full_domain_name = "TO";
elseif (preg_match('/name = (.*).\n/', $raw, $matches))
	$this->full_domain_name = $matches[1];
elseif (preg_match('/in-addr\.arpa[.:]* (.*)\n/', $raw, $matches))
	$this->full_domain_name = $this->nslookup_error[$matches[1]];
} //nslookup
/***************************************/
function host($ip) {
$raw = $this->raw_nsr = shell_exec("host -W 3 {$ip}");
if (strpos($raw, "timed out") !== false)
	$this->full_domain_name = "TO";
else {
	$raw = (($raw ? end(explode(' ', $raw)) : "hosterr"));
	$this->full_domain_name = rtrim($raw, " .\n\r\0"); //get the bugger off the end
	}
if (strlen($this->full_domain_name) < 2)
	$this->full_domain_name = "(empty)";
} //host
/****************************************************/
function __construct($ipx="", $ip="", $ecstatic="") {
global $wpdb;
if ($ipx AND $ip AND $ecstatic) {
	switch ($ecstatic->options["dom_method"]) {
		case 2:
			$this->nslookup($ip);
			break;
		case 4:
			$this->dig($ip);
			break;
		case 8:
			$this->ghba($ip); //gethostbyaddr()
			break;
		case 16:
			$this->dgr($ip); //dns_get_record()
			break;
		case 1:
		default:
			$this->host($ip);
			break;
		}
	$fdn = array_reverse(explode(".", $this->full_domain_name));
	if (count($fdn) > 1) {
		if (strlen($fdn[0]) == 2 AND count($fdn) > 2) //them furrin' two letter domain end designations
			$this->domain_name = $fdn[2] . "." . $fdn[1] . "." . $fdn[0];
		else
			$this->domain_name = $fdn[1] . "." . $fdn[0];
		}
	else
		$this->domain_name = $fdn[0];
	$wpdb->query($wpdb->prepare("UPDATE {$ecstatic->iurr_tables["ip"]} SET domain=%s WHERE id=%d", $this->domain_name, $ipx));
	}
} //constructor
} //class ecstatic_get_host
/***********************************************************************************/
/***********************************************************************************/
class act extends ecstatic {

public $ip = ''; //REMOTE_ADDR
public $ua = ''; //HTTP_USER_AGENT
public $ref = ''; //HTTP_REFERER
public $ruri = ''; //REQUEST_URI
private $scorebits = 0;
private $listbits = 0;

/***********************************************************************************/
function is_in_lists() { //wlist, nolog, kill, spider
global $wpdb;
$ip2checkf = (float)sprintf("%u", ip2long($this->ip));
$ua2check = str_replace(" ", "", strtolower($this->ua));
$record = $wpdb->get_results("SELECT id, token, type, wnks FROM $this->aux_lists_table");
foreach ($record as $rec) {
	switch ($rec->type) {
		case "ip":
			$this->load_ips($rec->token);
			if ($ip2checkf >= $this->ips[$rec->token]["min"] AND $ip2checkf <= $this->ips[$rec->token]["max"]) {
				$this->listbits |= $rec->wnks;
				$wpdb->query($wpdb->prepare("UPDATE $this->aux_lists_table SET hits=hits+1, lastseen=%d WHERE id=%d", $this->datetime, $rec->id));
				}
			break;
		case "ua":
			if (strpos($ua2check, $rec->token) !== false) {
				$this->listbits |= $rec->wnks;
				$wpdb->query($wpdb->prepare("UPDATE $this->aux_lists_table SET hits=hits+1, lastseen=%d WHERE id=%d", $this->datetime, $rec->id));
				}
			break;
		case "ref":
			if (strpos($this->ref, $rec->token) !== false) {
				$this->listbits |= $rec->wnks;
				$wpdb->query($wpdb->prepare("UPDATE $this->aux_lists_table SET hits=hits+1, lastseen=%d WHERE id=%d", $this->datetime, $rec->id));
				}
			break;
		case "ruri":
			if (strpos($this->ruri, $rec->token) !== false) {
				$this->listbits |= $rec->wnks;
				$wpdb->query($wpdb->prepare("UPDATE $this->aux_lists_table SET hits=hits+1, lastseen=%d WHERE id=%d", $this->datetime, $rec->id));
				}
			break;
		} //switch
	} //foreach
} //is_in_lists

/***********************************************************************************/
function hit_parade() {
global $wpdb;

if (isset($_SERVER['HTTP_X_MOZ'])) {
	if ($_SERVER['HTTP_X_MOZ'] == 'prefetch' AND $this->options["noprefetch"]) {
	    header('HTTP/1.0 403 Forbidden');
    	exit("403: Forbidden<br><br>Prefetching not allowed.");
    	}
	}
$this->ip = $_SERVER['REMOTE_ADDR'];
$this->ua = (isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : '');
$this->ref = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '');
//$this->ruri = (isset($_SERVER["REQUEST_URI"]) ? $_SERVER["REQUEST_URI"] : '');
if (isset($_SERVER['REQUEST_URI']))
	$this->ruri = $_SERVER['REQUEST_URI'];
elseif (isset($_SERVER['QUERY_STRING']))
	$this->ruri = $_SERVER['SCRIPT_NAME'] .'?'. $_SERVER['QUERY_STRING'];
elseif (isset($_SERVER['argv']))
		$this->ruri = $_SERVER['SCRIPT_NAME'] .'?'. $_SERVER['argv'][0]; //substr($_SERVER['argv'][0], strpos($_SERVER['argv'][0], ';') + 1)
else
	$this->ruri = $_SERVER['SCRIPT_NAME'];
$this->ruri = '/'. ltrim($this->ruri, '/');

if ($this->ip == "") { //does this ever happen???
	$this->score += $this->options["mal_ip"];
	$this->scorebits |= 0x1; //00000001b
	}
if ($this->ip != long2ip(ip2long($this->ip))) {
	$this->listbits |= 0x80; //10000000b
	$this->score += $this->options["mal_ip"];
	$this->scorebits |= 0x1; //00000001b
	}
$this->is_in_lists(); //sets $this->listbits invalid wlist nolog kill spider 10001111b
if ($this->listbits & 0x2) //00000010b - kilt
	$this->score += 10;
if ($this->ua == "") {
	$this->score += $this->options["empty_ua"];
	$this->scorebits |= 0x2; //00000010b
	}
if (strpos($this->ref, $this->schost) === 0) //don't record one's own referrers
	$this->ref = "";
if ($this->ref == "") {
	$this->score += $this->options["empty_ref"];
	$this->scorebits |= 0x4; //00000100b
	}
if (strpos($this->ruri, "wp-login.php") !== false) {
	$this->score += $this->options["login"];
	$this->scorebits |= 0x10; //00010000b
	}
if (strpos($this->ruri, "lostpassword") !== false) {
	$this->score += $this->options["lostpassword"];
	$this->scorebits |= 0x20; //00100000b
	}
if (strpos($this->ruri, "wp-trackback") !== false) {
	$this->score += $this->options["trackback"];
	$this->scorebits |= 0x40; //01000000b
	}
/*
if (preg_match("/.css$|.js$|.ico$/i", $this->ruri))
	return false;
if (stristr($this->ruri, "/wp-content/plugins") == true)
	return false;
if (stristr($this->ruri, "/wp-content/themes") == true)
	return false;
if ($this->ip == "127.0.0.1")
	return false;
*/
return true;
} //hit_parade

/***********************************************************************************/
function append_hit() {
global $wpdb;
$iz = array("ip" => $this->ip, "ua" => $this->ua, "ref" => $this->ref, "ruri" => $this->ruri);
$idz = array("ip" => 0, "ua" => 0, "ref" => 0, "ruri" => 0);

$type = "reg";
if (strpos($this->ruri, "feed") !== false)
	$type = "feed";
if (preg_match("/bot|spider|crawl/i", $this->ua) OR ($this->listbits & 1)) { //wnks 0001b - spider/bot
	$type = "bot";
	if ($this->options["block_new_bots"] AND !($this->listbits & 1)) {
		$this->score += 10;
		$this->scorebits |= 0x100; //New bot 000100000000b
		}
	}

if ($this->options["wtf"]) {
	$fifteen_minutes_ago = $this->datetime - 900;
	$wtf = $wpdb->get_results("SELECT datetime, ip, ua, ref, scorebits FROM {$this->hits_table} WHERE datetime > '{$fifteen_minutes_ago}' ORDER BY datetime DESC");
	}
foreach ($this->iurr_tables as $key=>$table) {
	$row = $wpdb->get_row($wpdb->prepare("SELECT id, score FROM $table WHERE $key=%s", $iz[$key]));
	if ($row->id) {
		$idz[$key] = $row->id;
		$this->score += $row->score;
		if ($this->options["wtf"] AND $this->score < 10 AND ($key == "ip" OR $key == "ua" OR ($key == "ref" AND $this->ref != ""))) { //check for speed scrapers, etc.
			$x = 0;
			foreach ($wtf as $wt) {
				if ($wt->$key == $idz[$key]) {
					$x++;
					$t = $this->datetime - $wt->datetime;
					if (($x >= ($this->options["wtf_x"]-1) AND ($t/$x) <= $this->options["wtf_secs"]) OR $wt->scorebits & 0x8) {
						$this->score += 10;
						$this->scorebits |= 0x8; //00001000b wtf bit - time seconds / hits
						break;
						}
					}
				}
			}
		}
	elseif (!($this->listbits & 4)) { //wnks 0100b - No Log
		switch ($key) {
			case "ua": //id, ua, aux, browser, os, renderer, score
				$wpdb->query($wpdb->prepare("INSERT INTO $table VALUES (null, %s, DEFAULT, %s, %s, %s, DEFAULT)", $this->ua, "", "", ""));
				break;
			case "ip": //id, ip, aux, score, domain
				$wpdb->query($wpdb->prepare("INSERT INTO $table VALUES (null, %s, DEFAULT, DEFAULT, %s)", $this->ip, ""));
				break;
			case "ref": //id, ref, aux, score
				$wpdb->query($wpdb->prepare("INSERT INTO $table VALUES (null, %s, DEFAULT, DEFAULT)", $this->ref));
				break;
			case "ruri": //id, ruri, aux, score
				$wpdb->query($wpdb->prepare("INSERT INTO $table VALUES (null, %s, %d, DEFAULT)", $this->ruri, 0)); //must set the default aux to 0
				break;
			} //switch
		if (mysql_affected_rows() > 0)
			$idz[$key] = mysql_insert_id();
		}
	} //foreach

if ($this->options["dom_check"] AND $this->score >= $this->options["dom_check_at"] AND $this->score < 10) { //extra domain test
	$dom = new ecstatic_get_host($idz["ip"], $this->ip, $this);
	if ($dom->is_domain_error()) {
		$this->score += $this->options["dom_check_score"];
		$this->scorebits |= 0x80; //10000000b bad dom
		}
	}
if (($this->listbits & 8) AND (!($this->listbits & 0x10))) //wnks 00011000b - xWhiteList AND WhiteList
	$this->score = -1;
if (!($this->listbits & 4)) { //wnks 0100b - No Log
	if ($this->score < 10) {
		$ind = array("reg" => "UPDATE $this->cumulative_table SET regi=regi+1 WHERE day=%d", "bot" => "UPDATE $this->cumulative_table SET boti=boti+1 WHERE day=%d", "feed" => "UPDATE $this->cumulative_table SET feedi=feedi+1 WHERE day=%d");
		$page = array("reg" => "UPDATE $this->cumulative_table SET regp=regp+1 WHERE day=%d", "bot" => "UPDATE $this->cumulative_table SET botp=botp+1 WHERE day=%d", "feed" => "UPDATE $this->cumulative_table SET feedp=feedp+1 WHERE day=%d");
		$big_today = $this->datetime - ($this->datetime + (60 * 60 * $this->timezoneoffset)) % (60*60*24); //midnight zero
		$today = gmdate("Ymd", $big_today);
		$cutoff = $this->datetime - ($this->options["newvisitorminutes"] * 60);
		if (!$wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $this->cumulative_table WHERE day=%d", $today)))
			$wpdb->query($wpdb->prepare("INSERT INTO $this->cumulative_table VALUES (%d, DEFAULT, DEFAULT, DEFAULT, DEFAULT, DEFAULT, DEFAULT)", $today));
		$wpdb->query($wpdb->prepare($page[$type],$today));
		if ($type != "bot")
			$wpdb->query($wpdb->prepare("UPDATE {$this->iurr_tables["ruri"]} SET aux=aux+1 WHERE id=%d", $idz["ruri"])); //page visits
		if ($type != "reg" AND !$wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $this->hits_table WHERE ip=%d AND ua=%d AND datetime>%d",$idz["ip"],$idz["ua"],$big_today)))
			$wpdb->query($wpdb->prepare($ind[$type],$today));
		elseif ($type == "reg" AND !$wpdb->get_var($wpdb->prepare("SELECT count(*) FROM $this->hits_table WHERE ip=%d AND ua=%d AND datetime>%d",$idz["ip"],$idz["ua"],$cutoff)))
			$wpdb->query($wpdb->prepare($ind[$type],$today));
		} //score
	$wpdb->query($wpdb->prepare("INSERT INTO $this->hits_table (datetime, ip, ua, ref, ruri, scorebits, score) VALUES (%s, %d, %d, %d, %d, %d, %d)", $this->datetime, $idz["ip"], $idz["ua"], $idz["ref"], $idz["ruri"], $this->scorebits, $this->score));
	} //no log
} //append_hit

/***********************************************************************************/
function __construct() {
parent::__construct();
}
} //class act

/***********************************************************************************/
function ecstatic_new_hit() {
if (isset($_POST["ecstatit"])) { //must go here to beat any header output
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_forms.php');
	$ecstatic = new ecstatic_formproc();
	$ecstatic->form_processor(); //function exit()s and doesn't return
	}
$ecstatic = new act();
if (!is_user_logged_in() OR $ecstatic->options["collectloggeduser"] OR $ecstatic->logsubadmin)
	if ($ecstatic->hit_parade())
		$ecstatic->append_hit();

if ($ecstatic->options["estats"] > 1234 AND $ecstatic->options["estats"] < $ecstatic->datetime) { //eMail stats
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_estats.php');
	}

if ($ecstatic->score > 9) {
    header('HTTP/1.0 403 Forbidden');
	exit("<br><br><br><center>403:&nbsp; Forbidden</center><br><br>");
	}
} //ecstatic_new_hit

/***********************************************************************************/
function ecstatic_integrate() {
include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_interface.php');
ecstatic_integrate_menu();
}
/***********************************************************************************/
function ecstatic_widget_fidget() {
$ecstatic = new ecstatic();
if ($ecstatic->options["enablewidget"]) {
	include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_widget.php');
	register_widget('ecstatic_widget');
	}
} //ecstatic_widget_fidget

/****************************************************/
function ecstatic_details_search() { //AJAX mania - called from ecstatic.js
include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_interface.php');
include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_details.php');
$ecstatic = new ecstatic_details();
$ecstatic->assoc_panel("srch", $_POST['detsrch']);
exit;
}
/****************************************************/
function ecstatic_wnks_filter() { //AJAX mania - ditto above
include_once(WP_PLUGIN_DIR . "/" . dirname(plugin_basename(__FILE__)) . '/ecstatic_details.php');
$ecstatic = new ecstatic();
$wnkstable = new ecstatic_wnkstable($ecstatic);
$wnkstable->show();
exit;
}
/****************************************************/
function ecstatic_dummy_function() { //more AJAXania - fool Wordpress AJAX interface - function preempted by "ecstatit" in ecstatic_new_hit()
exit;
}

// Pre-2.6 compatibility
if ( ! defined( 'WP_CONTENT_URL' ) )
      define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
      define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
      define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );

add_action('init', 'ecstatic_new_hit');
add_action('admin_menu', 'ecstatic_integrate');
add_action('widgets_init', 'ecstatic_widget_fidget');
add_action('wp_ajax_details_search', 'ecstatic_details_search');
add_action('wp_ajax_wnks_filter', 'ecstatic_wnks_filter');
add_action('wp_ajax_dummy_function', 'ecstatic_dummy_function');
?>